@echo off
rem ======================================================================
::
::  GENERATE INSTALL SCRIPT FOR ALL CHOCOLATEY PACKAGES
::
::  Run this script to generate an installer that reinstalls all your
::  chocolatey packages. You can use it to put the same packages on
::  another computer or for desaster recovery (then you should create a 
::  job in the taskplaner).
::
::  To list packages (choco list -lo) you need administrator privileges.
::
rem ----------------------------------------------------------------------
::  2014-08-13  axelhahn@axel-hahn.de  first version
rem ======================================================================


rem ----------------------------------------------------------------------
::  config
rem ----------------------------------------------------------------------
	set out=%~dp0\choco_install.bat
	set tmpfile="%temp%\chocolist.tmp"

rem ----------------------------------------------------------------------
::  main
rem ----------------------------------------------------------------------

	echo.
	echo ========== GENERATE CHOCO INSTALLER ==========
	echo.
	choco help >nul  || (
		echo ERROR: You need to be administrator to run this script.
		echo Press any key to exit.
		color cf
		pause >nul
		exit 1
	)

	rem ----------------------------------------------------------------------
	del %tmpfile% 2>nul
	echo --- fetching currently installed packages ...
	for /F "tokens=1 delims= " %%a in ('choco list -lo') do (
		echo %%a
		echo :: CHOCO:%%a >>%tmpfile%
	)

	rem ----------------------------------------------------------------------
	echo.
	echo --- creating %out% ...
	echo @echo off >%out%
	echo rem ----- info >>%out%
	echo :: >>%out%
	echo :: This installer script was generated - do not modify it! >>%out%
	echo :: generator: %0 - %username%@%computername% >>%out%
	echo :: creation time: %DATE% - %TIME% >>%out%
	echo :: >>%out%
	echo rem ----- package list >>%out%
	type %tmpfile% >>%out%
	echo :: >>%out%
	echo echo. >>%out%
	echo echo ========== CHOCO INSTALLER - generated %DATE% ========== >>%out%
	echo echo. >>%out%
	echo choco help ^>nul ^|^| ^( >>%out%
	echo      color cf >>%out%
	echo      echo ERROR: cannot start the installation. >>%out%
	echo      echo - install chocoloatey - see command on chocolatey.org >>%out%
	echo      echo - Run this script as administrator >>%out%
	echo      echo Press any key to exit.>>%out%
	echo      pause ^>nul>>%out%
	echo      exit 1>>%out%
	echo )>>%out%
	echo for /F "tokens=2 delims=:" %%%%a in ('type %%0 ^^^| findstr /v findstr ^^^| findstr "^::\ CHOCO:" ') do ( >>%out%
	echo     echo --- install %%%%a >>%out%
	echo     choco install %%%%a >>%out%
	echo     echo returncode %%ERRORLEVEL%% >>%out%
	echo     echo.>>%out%
	echo )>>%out%
	echo echo --- Done. Press any key to exit. >>%out%
	echo pause ^>nul >>%out%
	del %tmpfile%

	rem ----------------------------------------------------------------------
	echo.
	echo --- output:
	echo The installer script is here:
	dir %out% | findstr "^[0-9]"
	echo.
	echo --- Done.
	timeout /t 10

rem ----------------------------------------------------------------------
::  end
rem ----------------------------------------------------------------------